/**
 *    AudioSettings.java
 *    Copyright (C) 2010 New Zealand Digital Library, http://expeditee.org
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.expeditee.settings.audio;

import org.expeditee.items.Text;
import org.expeditee.setting.BooleanSetting;
import org.expeditee.setting.IntegerSetting;
import org.expeditee.setting.StringSetting;

/**
 * The settings for the audio support provided by the Apollo project
 * @author davidb
 */
public abstract class AudioSettings {
	
	public static final int PLAYBACK_CLOCK_RESOLUTION = 50;
		
	public static final IntegerSetting PlaybackClockResolution = new IntegerSetting("Clock resolution (in milliseconds) for graphical updates when playing audio", 50);

}
